package RTOpts "
This file is part of OpenModelica.

Copyright (c) 1998-2006, Linkpings universitet, Department of
Computer and Information Science, PELAB

All rights reserved.

(The new BSD license, see also
http://www.opensource.org/licenses/bsd-license.php)


Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

 Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

 Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in
  the documentation and/or other materials provided with the
  distribution.

 Neither the name of Linkpings universitet nor the names of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
\"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  
  file:	 RTOpts.mo
  module:      RTOpts
  description: Runtime options
 
  RCS: $Id: RTOpts.mo 2824 2007-06-11 09:11:38Z adrpo $
 
  This module takes care of command line options. It is possible to 
  ask it what flags are set, what arguments were given etc.
   
  This module is used pretty much everywhere where debug calls are made.
  
"

public function args
  input list<String> inStringLst;
  output list<String> outStringLst;

  external "C" ;
end args;

public function typeinfo
  output Boolean outBoolean;

  external "C" ;
end typeinfo;

public function splitArrays
  output Boolean outBoolean;

  external "C" ;
end splitArrays;

public function paramsStruct
  output Boolean outBoolean;

  external "C" ;
end paramsStruct;

public function modelicaOutput
  output Boolean outBoolean;

  external "C" ;
end modelicaOutput;

public function debugFlag
  input String inString;
  output Boolean outBoolean;

  external "C" ;
end debugFlag;

public function noProc
  output Integer outInteger;

  external "C" ;
end noProc;

public function setEliminationLevel
  input Integer level;

  external "C" ;
end setEliminationLevel;

public function eliminationLevel
  output Integer level;

  external "C" ;
end eliminationLevel;

public function latency
  output Real outReal;

  external "C" ;
end latency;

public function bandwidth
  output Real outReal;

  external "C" ;
end bandwidth;

public function simulationCg
  output Boolean outBoolean;

  external "C" ;
end simulationCg;

public function simulationCodeTarget
"@author adrpo
 returns: 'gcc' or 'msvc'
 usage: omc [+target=gcc|msvc], default to 'gcc'."
  output String outCodeTarget;

  external "C" ;
end simulationCodeTarget;

public function silent
  output Boolean outBoolean;

  external "C" ;
end silent;

public function versionRequest
  output Boolean outBoolean;
  
  external "C";
end versionRequest;

/* 
 * adrpo 2007-06-11
 * returns true if MetaModelica grammar is accepted
 * returns false if only Modelica grammar is accepted
 */
public function acceptMetaModelicaGrammar
"@author adrpo
 returns: true if MetaModelica grammar is accepted or false otherwise
 usage: omc [+g=Modelica|MetaModelica], default to 'Modelica'."
  output Boolean outBoolean;
  
  external "C";
end acceptMetaModelicaGrammar;

end RTOpts;

